

#include "HTK_My_View.h"

TK_Status HTK_My_Initial_View::HTK_My_Initial_View() : HTK_Camera(TKE_View)
{
}

TK_Status HTK_My_Initial_View::Interpret(BStreamFileToolkit &tk, ID_Key key, int variant)
{
	HPoint pos, tar, up;
	float fieldx=0, fieldy=0;
	char proj[16];

	// query camera info from HOOPS/3dGS
	HC_Show_Camera(&pos, &tar, &up, fieldx, fieldy, proj); 

	m_settings[0] = pos.x; m_settings[1] = pos.y; m_settings[2] = pos.z;
	m_settings[3] = tar.x; m_settings[4] = tar.y; m_settings[5] = tar.z;
	m_settings[6] = up.x ; m_settings[7] = up.y ; m_settings[8] = up.z;
	m_settings[9] = fieldx ; m_settings[10] = fieldy;

	if(proj[0] == 'p')
		m_projection = TKO_Camera_Perspective;
	else
		m_projection = TKO_Camera_Orthographic;

	// we'll give the view a name of 'default'   If a view with this name is found during reading, it will be used
	// to setup the initial camera for the scene
	SetView("default");

	return TK_Normal;
}


TK_Status HTK_My_Initial_View::Execute(BStreamFileToolkit &tk) 
{
	TK_Status status = TK_Normal;

	HPoint pos, tar, up;
	float fieldx, fieldy;

	pos.Set(m_settings[0],m_settings[1],m_settings[2]);
	tar.Set(m_settings[3],m_settings[4],m_settings[5]);
	up.Set(m_settings[6],m_settings[7],m_settings[8]);
	fieldx = m_settings[9];
	fieldy = m_settings[10];

	char proj[16];

	if (m_projection == TKO_Camera_Perspective)
		strcpy(proj,"p");
	else if (m_projection == TKO_Camera_Orthographic)
		strcpy(proj,"o");
	else
		strcpy(proj,"s");

	if (!strcmp(GetView(),"default"))
	{
		// if the view is designated as the 'default', then we set the camera in the HOOPS scene-graph  
		HC_Set_Camera(pos, tar, up, fieldx, fieldy, proj);
	}

	return (status);
}
